/*global Drupal: false, jQuery: false */
/*jslint devel: true, browser: true, maxerr: 50, indent: 2 */
(function($) {
  "use strict";

  Drupal.yashare = {};
  Drupal.yashare.initialize = function (context, settings) {
    context = context || document;
    settings = settings || Drupal.settings;
    if (typeof Ya != 'undefined' && typeof Ya.share != 'undefined') {
      Drupal.yashare.initWidgets(context, settings);
    }
    else {
      $.ajax({
        url: '//yandex.st/share/share.js',
        dataType: 'script',
        cache: true, //otherwise will get fresh copy every page load, this is why not $.getScript().
        success: function (data, textStatus, jqXHR) {
          Drupal.yashare.initWidgets(context, settings);
        }
      });
    }
  };
  Drupal.yashare.initWidgets = function (context, settings) {
    $.each(settings.yashare, function (index, value) {
      $('#' + index + ':not(.yashare-processed)', context).addClass('yashare-processed').each(function () {
        new Ya.share(value);
      });
    });
  };

  // Drupal.yashare.initialize();

  Drupal.behaviors.yashare = {};
  Drupal.behaviors.yashare.attach = function (context, settings) {
    Drupal.yashare.initialize(context, settings);
  };

})(jQuery);
